%define zmwebdir /var/www/html/zm
%define zmcgidir /var/www/cgi-bin/zm

Summary: Video camera security and surveillance solution
Name: ZoneMinder
Version: 1.23.3
Release: 1.0%{?dist}
License: GPL
Group: Applications/Internet
Source: http://www2.zoneminder.com/downloads/%{name}-%{version}.tar.gz
Source1: http://www.charliemouse.com/code/cambozola/cambozola-0.68.tar.gz
Source3: redalert.wav
Patch1: ZoneMinder-tweaks.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
URL: http://www.zoneminder.com/
Requires: ffmpeg
BuildRequires: ffmpeg-devel gnutls-devel
BuildRequires:  automake
BuildRequires:  mysql-devel pcre-devel libjpeg-devel
BuildRequires:  perl(Archive::Tar) perl(Archive::Zip)
BuildRequires:  perl(Date::Manip) perl(DBD::mysql)
BuildRequires:  perl(ExtUtils::MakeMaker) perl(LWP::UserAgent)
BuildRequires:  perl(MIME::Entity) perl(MIME::Lite) perl(PHP::Serialization)
Requires:       httpd php php-mysql
Requires:       perl(DBD::mysql)


%description
ZoneMinder is intended for use in single or multi-camera video security
applications, including commercial or home CCTV, theft prevention and 
child or family member or home monitoring and other care scenarios. It 
supports capture, analysis, recording, and monitoring of video data 
coming from one or more video or network cameras attached to a Linux 
system. ZoneMinder also support web and semi-automatic control of 
Pan/Tilt/Zoom cameras using a variety of protocols. It is suitable for 
use as a home video security system and for commercial or professional 
video security and surveillance.

%prep
%setup
%patch1 -p1 -b .tweaks
gunzip -c %{SOURCE1} | tar xf - cambozola-*/dist/cambozola.jar
cat <<EOF >> db/zm_create.sql.in
update Config set Value = '/cgi-bin/zm/nph-zms' where Name = 'ZM_PATH_ZMS';
update Config set DefaultValue = '/cgi-bin/zm/nph-zms' where Name = 'ZM_PATH_ZMS';
update Config set Value = '/usr/bin/mpeg_encode' where Name = 'ZM_PATH_MPEG_ENCODE';
update Config set DefaultValue = '/usr/bin/mpeg_encode' where Name = 'ZM_PATH_MPEG_ENCODE';
update Config set Value = '/usr/bin/ffmpeg' where Name = 'ZM_PATH_FFMPEG';
update Config set DefaultValue = '/usr/bin/ffmpeg' where Name = 'ZM_PATH_FFMPEG';
update Config set Value = '/var/log/zm/zm_debug.log' where Name = 'ZM_EXTRA_DEBUG_LOG';
update Config set DefaultValue = '/var/log/zm/zm_debug.log' where Name = 'ZM_EXTRA_DEBUG_LOG';
update Config set Value = '/var/run/zm' where Name = 'ZM_PATH_SOCKS';
update Config set DefaultValue = '/var/run/zm' where Name = 'ZM_PATH_SOCKS';
update Config set Value = '/var/log/zm' where Name = 'ZM_PATH_LOGS';
update Config set DefaultValue = '/var/log/zm' where Name = 'ZM_PATH_LOGS';
use mysql;
grant select,insert,update,delete on zm.* to 'zmuser'@localhost identified by 'zmpass';
EOF

%build
# we set webuser and webgroup to user doing compilation otherwise
# make install will fail, we'll fix it in files section
%configure --with-libarch=%{_lib} --with-mysql=/usr --with-ffmpeg=/usr \
	--with-webdir=%{zmwebdir} --with-cgidir=%{zmcgidir} \
	--with-webuser=`id -u -n` --with-webgroup=`id -g -n` \
	--enable-debug=no --enable-crashtrace=yes
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/%{_bindir} $RPM_BUILD_ROOT/var/run/zm
make install DESTDIR=$RPM_BUILD_ROOT ZM_RUNDIR=$RPM_BUILD_ROOT/var/run/zm
rm -f `find $RPM_BUILD_ROOT -type f -name perllocal.pod -o -name .packlist`
chmod -R a+rX,u+w $RPM_BUILD_ROOT
perl -pi -e 's|ZM_WEB_USER=.*|ZM_WEB_USER=apache|' $RPM_BUILD_ROOT%{_sysconfdir}/zm.conf
perl -pi -e 's|ZM_WEB_GROUP=.*|ZM_WEB_GROUP=apache|' $RPM_BUILD_ROOT%{_sysconfdir}/zm.conf
# install update scripts
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/ZoneMinder/db
install -m 644 db/*.sql $RPM_BUILD_ROOT/%{_datadir}/ZoneMinder/db
perl -pi -e 's|/usr/local/bin|/usr/bin|g' $RPM_BUILD_ROOT/%{_datadir}/ZoneMinder/db/*
perl -pi -e 's|ZM_PATH_BUILD=.*|ZM_PATH_BUILD=%{_datadir}/ZoneMinder|' $RPM_BUILD_ROOT%{_sysconfdir}/zm.conf
perl -pi -e 's|ZM_PATH_UPDATE=.*|ZM_PATH_UPDATE=%{_datadir}/ZoneMinder/db|' $RPM_BUILD_ROOT%{_sysconfdir}/zm.conf
# install init script
mkdir -p  $RPM_BUILD_ROOT%{_initrddir}
install -m 755 scripts/zm $RPM_BUILD_ROOT%{_initrddir}/ZoneMinder
# Remove some scripts we do not want - mostly due to dependencies
rm -f $RPM_BUILD_ROOT%{_bindir}/zmx10.pl
# Log files will go here
mkdir -p $RPM_BUILD_ROOT/var/log/zm

# default apache config
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d
cat >> $RPM_BUILD_ROOT%{_sysconfdir}/httpd/conf.d/zm.conf <<ENDHTTPD
<Directory "/var/www/html/zm">
   AllowOverride Limit
   Order allow,deny
   Allow from all
   Options SymLinksIfOwnerMatch
</Directory>
ENDHTTPD

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add ZoneMinder
/usr/bin/chcon -t httpd_unconfined_script_exec_t /usr/bin/zmdc.pl /usr/bin/zmu /var/www/cgi-bin/zm/nph-zms

%preun
if [ "$1" = 0 ] ; then
  service ZoneMinder stop >/dev/null 2>&1
  /sbin/chkconfig --del ZoneMinder
fi

%postun
if [ "$1" -ge "1" ]; then
  service ZoneMinder condrestart >/dev/null 2>&1
fi



%files
%defattr(-,root,root)
%doc AUTHORS COPYING ChangeLog NEWS README* TODO
%{_bindir}/*
%{_mandir}/man3/*
%attr(770,root,apache) %dir /var/run/zm
%attr(770,root,apache) %dir /var/log/zm
%dir %{zmcgidir}
%{zmcgidir}/*
%dir %{zmwebdir}
%{zmwebdir}/favicon.ico
%{zmwebdir}/graphics
%{zmwebdir}/*php
%{zmwebdir}/*css
%{zmwebdir}/*js
%attr(770,root,apache) %dir %{zmwebdir}/events
%attr(770,root,apache) %dir %{zmwebdir}/images
%attr(770,root,apache) %dir %{zmwebdir}/sounds
%attr(770,root,apache) %dir %{zmwebdir}/temp
%{_libdir}/perl5/*/*/ZoneMinder.pm
%{_libdir}/perl5/*/*/ZoneMinder
%config(noreplace) %attr(640,root,apache) %{_sysconfdir}/zm.conf
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/httpd/conf.d/zm.conf
%{_initrddir}/ZoneMinder
%{_datadir}/ZoneMinder

%changelog
* Thu Aug 03 2006 Josko Plazonic <plazonic@math.princeton.edu>
- initial build, some tweaks in preparation for selinux compatibility
  but lots to go to get there and no time for now, works with
  permissive selinux for now - tweak later
